/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import { ServiceClient, ServiceClientOptions, ServiceCallback, HttpOperationResponse, ServiceClientCredentials } from 'ms-rest';
import * as models from "./models";

export default class EnigmaVaultAPI extends ServiceClient {
  /**
   * @class
   * Initializes a new instance of the EnigmaVaultAPI class.
   * @constructor
   *
   * @param {credentials} credentials - Subscription credentials which uniquely identify client subscription.
   *
   * @param {string} [baseUri] - The base URI of the service.
   *
   * @param {object} [options] - The parameter options
   *
   * @param {Array} [options.filters] - Filters to be added to the request pipeline
   *
   * @param {object} [options.requestOptions] - Options for the underlying request object
   * {@link https://github.com/request/request#requestoptions-callback Options doc}
   *
   * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
   *
   */
  constructor(credentials: ServiceClientCredentials, baseUri?: string, options?: ServiceClientOptions);

  credentials: ServiceClientCredentials;


  /**
   * @summary Store a card.
   *
   * When a card is stored in the vault, the original card information is not
   * retrievable by the client without the cardvault_raw scope (contact support).
   * The CVV's ttl is set to the same ttl as the card unless the card is stored
   * permanently. If the card is stored permanently, the CVV's ttl is set to 30
   * minutes. The CVV is purged after its first use or after its ttl expires,
   * whichever comes first. After the card's ttl, the card is deleted. To make
   * the card permanent, leave out the ttl property. The full card number can be
   * used through the proxy endpoint. You can get the first six, the last four,
   * full name, and expiration from /cardvault/cards (GET).
   *
   * @param {object} body Card information.
   *
   * @param {string} body.ccn Card number.
   *
   * @param {string} body.fullName Full name located on the card.
   *
   * @param {number} body.expMonth Expiration month.
   *
   * @param {number} body.expYear Expiration year.
   *
   * @param {string} [body.cvv] Card verification value (security code). This
   * value is not stored permanently.
   *
   * @param {string} body.cardType Type of card (amex, diners_club_carte_blanche,
   * diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {number} body.cvvTtl Remaining ttl before the CVV gets deleted.
   *
   * @param {number} [body.ttl] The card's time to live in seconds. Once expired
   * the
   * card is deleted from the vault.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  storeCardWithHttpOperationResponse(body: models.CardModel, xApiVersion: string, options?: { preserveFormat? : boolean, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Store a card.
   *
   * When a card is stored in the vault, the original card information is not
   * retrievable by the client without the cardvault_raw scope (contact support).
   * The CVV's ttl is set to the same ttl as the card unless the card is stored
   * permanently. If the card is stored permanently, the CVV's ttl is set to 30
   * minutes. The CVV is purged after its first use or after its ttl expires,
   * whichever comes first. After the card's ttl, the card is deleted. To make
   * the card permanent, leave out the ttl property. The full card number can be
   * used through the proxy endpoint. You can get the first six, the last four,
   * full name, and expiration from /cardvault/cards (GET).
   *
   * @param {object} body Card information.
   *
   * @param {string} body.ccn Card number.
   *
   * @param {string} body.fullName Full name located on the card.
   *
   * @param {number} body.expMonth Expiration month.
   *
   * @param {number} body.expYear Expiration year.
   *
   * @param {string} [body.cvv] Card verification value (security code). This
   * value is not stored permanently.
   *
   * @param {string} body.cardType Type of card (amex, diners_club_carte_blanche,
   * diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {number} body.cvvTtl Remaining ttl before the CVV gets deleted.
   *
   * @param {number} [body.ttl] The card's time to live in seconds. Once expired
   * the
   * card is deleted from the vault.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  storeCard(body: models.CardModel, xApiVersion: string, options?: { preserveFormat? : boolean, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  storeCard(body: models.CardModel, xApiVersion: string, callback: ServiceCallback<any>): void;
  storeCard(body: models.CardModel, xApiVersion: string, options: { preserveFormat? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a card.
   *
   * Provides card data. The first six and the last four are included in the
   * response. The ttl values represent the time remaining in seconds until that
   * item is purged. the original card information is not retreivable by the
   * client without the cardvault_raw scope (contact support). If you have the
   * proper scope, use the cardvault/raw/cards endpoint.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  retrieveCardWithHttpOperationResponse(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a card.
   *
   * Provides card data. The first six and the last four are included in the
   * response. The ttl values represent the time remaining in seconds until that
   * item is purged. the original card information is not retreivable by the
   * client without the cardvault_raw scope (contact support). If you have the
   * proper scope, use the cardvault/raw/cards endpoint.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  retrieveCard(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  retrieveCard(cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  retrieveCard(cardToken: string, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Delete a card.
   *
   * Returns an empty 204 response on success.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  deleteCardWithHttpOperationResponse(cardToken: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Delete a card.
   *
   * Returns an empty 204 response on success.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  deleteCard(cardToken: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  deleteCard(cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  deleteCard(cardToken: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a card. Scope cardvault_raw only.
   *
   * Special endpoint to retreive raw card data. It can only be used with the
   * cardvault_raw scope.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  retrieveRawCardWithHttpOperationResponse(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a card. Scope cardvault_raw only.
   *
   * Special endpoint to retreive raw card data. It can only be used with the
   * cardvault_raw scope.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  retrieveRawCard(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  retrieveRawCard(cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  retrieveRawCard(cardToken: string, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get an ephemeral key for a specific card token and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to use a card token. The destinationClientId is a valid Enigma Vault
   * clientId of the destination app. The time to live (ttl) is in seconds.
   *
   * @param {string} cardToken Reference to the vaulted card.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {number} [options.ttl] Time to live in seconds, max of 1800 seconds.
   * This is only applicable when
   * the card has a ttl of 0 (permanent). Otherwise the ephemeralKey ttl is set
   * to the card ttl.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCardEphemeralKeyWithHttpOperationResponse(cardToken: string, destinationClientId: string, xApiVersion: string, options?: { ttl? : number, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get an ephemeral key for a specific card token and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to use a card token. The destinationClientId is a valid Enigma Vault
   * clientId of the destination app. The time to live (ttl) is in seconds.
   *
   * @param {string} cardToken Reference to the vaulted card.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {number} [options.ttl] Time to live in seconds, max of 1800 seconds.
   * This is only applicable when
   * the card has a ttl of 0 (permanent). Otherwise the ephemeralKey ttl is set
   * to the card ttl.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCardEphemeralKey(cardToken: string, destinationClientId: string, xApiVersion: string, options?: { ttl? : number, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCardEphemeralKey(cardToken: string, destinationClientId: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getCardEphemeralKey(cardToken: string, destinationClientId: string, xApiVersion: string, options: { ttl? : number, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get the current ttl of a card.
   *
   * The card's time to live in seconds. Once expired the card is deleted from
   * the vault. If -1, the card lives forever until manually deleted.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getTtlWithHttpOperationResponse(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get the current ttl of a card.
   *
   * The card's time to live in seconds. Once expired the card is deleted from
   * the vault. If -1, the card lives forever until manually deleted.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getTtl(cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getTtl(cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getTtl(cardToken: string, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Update the card ttl.
   *
   * Adjusts the time (seconds) until deletion. Additional time cannot be added
   * to the CVV's ttl.
   *
   * @param {object} body New card ttl value.
   *
   * @param {number} body.ttl The card's time to live in seconds. Once expired
   * the
   * card is deleted from the vault. If -1, card lives forever until
   * manually deleted.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  updateCardTtlWithHttpOperationResponse(body: models.CardTtlModel, cardToken: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Update the card ttl.
   *
   * Adjusts the time (seconds) until deletion. Additional time cannot be added
   * to the CVV's ttl.
   *
   * @param {object} body New card ttl value.
   *
   * @param {number} body.ttl The card's time to live in seconds. Once expired
   * the
   * card is deleted from the vault. If -1, card lives forever until
   * manually deleted.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  updateCardTtl(body: models.CardTtlModel, cardToken: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  updateCardTtl(body: models.CardTtlModel, cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  updateCardTtl(body: models.CardTtlModel, cardToken: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Send detokenized card data and transaction info to a payment
   * gateway.
   *
   * This endpoint allows you to use a stored card without touching the card
   * data. Build out the request meant for the upstream url and then use the
   * following placeholders to have the endpoint populate them with card data:
   * ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
   * ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE.
   *
   * @param {object} body Token and gateway information.
   *
   * @param {string} body.url URL to use on the payment gateway request.
   *
   * @param {string} body.httpMethod HTTP method to use on the payment gateway
   * request.
   *
   * @param {array} [body.headers] Headers to use on the payment gateway request.
   *
   * @param {string} [body.body] Body to use on the payment gateway request.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  cardProxyWithHttpOperationResponse(body: models.CardProxyModel, cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Send detokenized card data and transaction info to a payment
   * gateway.
   *
   * This endpoint allows you to use a stored card without touching the card
   * data. Build out the request meant for the upstream url and then use the
   * following placeholders to have the endpoint populate them with card data:
   * ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
   * ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE.
   *
   * @param {object} body Token and gateway information.
   *
   * @param {string} body.url URL to use on the payment gateway request.
   *
   * @param {string} body.httpMethod HTTP method to use on the payment gateway
   * request.
   *
   * @param {array} [body.headers] Headers to use on the payment gateway request.
   *
   * @param {string} [body.body] Body to use on the payment gateway request.
   *
   * @param {string} cardToken Card token.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] Expiring key for temporary access.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  cardProxy(body: models.CardProxyModel, cardToken: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  cardProxy(body: models.CardProxyModel, cardToken: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  cardProxy(body: models.CardProxyModel, cardToken: string, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a url to the card processing UI.
   *
   * The card processing UI allows your customers to enter their card data and
   * process upstream with the payment gateway without your app touching it.
   * Build out the request meant for the upstream url and then use the following
   * placeholders to have the endpoint populate them with card data: ${total},
   * ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
   * ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE. The customer is redirected
   * back to your app (callback url) via POST with the parameter eVsessionId. You
   * can then use /cardvault/process/sessions/ to determine the adjudication. The
   * session information is available for 72 hours. If the customer choses to
   * save their card, it will be available through the sessions endpoint. If the
   * customer chooses to cancel or if the form timeouts, evException will have a
   * value within the POST callback. For cancels, evException's value will be
   * 'cancel'. For timeouts, the evException's value will be 'timeout'. There are
   * multiple ways to integrate the card process form. You can use it within a
   * popup, redirect or simple iframe.
   *
   * @param {object} body Gateway and cart information.
   *
   * @param {object} body.gatewayRequest
   *
   * @param {string} body.gatewayRequest.url URL to use on the payment gateway
   * request.
   *
   * @param {string} body.gatewayRequest.httpMethod HTTP method to use on the
   * payment gateway request.
   *
   * @param {array} [body.gatewayRequest.headers] Headers to use on the payment
   * gateway request.
   *
   * @param {string} [body.gatewayRequest.body] Body to use on the payment
   * gateway request.
   *
   * @param {object} body.cart
   *
   * @param {string} body.cart.cultureCode ISO 639-1 (language) and ISO 3166-1
   * (country) code.
   *
   * @param {array} body.cart.cartItems List of cart items.
   *
   * @param {number} body.cart.total Total of the cart item amounts. The total is
   * validated against the
   * sum of the cart item amounts.
   *
   * @param {boolean} body.cart.gatewayIntegersOnly Some payment gateways only
   * accept integers. If true, it will multiply
   * the total by 100. For instance, 10.01 will be submitted to the gateway
   * as 1001.
   *
   * @param {string} callbackUrl URL the user is redirected to after storing the
   * card.
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCard Show or hide the card visual.
   *
   * @param {number} ttl Form session time to live in seconds. After it expires,
   * the form can no
   * longer be used.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {string} [options.cardTypes] Card types, comma delimited. Omit for
   * any card.
   * (amex, diners_club_carte_blanche, diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {string} [options.cartTableBorderColor] The hex color of the cart
   * table header and border.
   *
   * @param {string} [options.cartTableAlternateRowColor] The hex color of the
   * cart table's alternating rows.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCardProcessFormWithHttpOperationResponse(body: models.CardProcessModel, callbackUrl: string, showTimer: boolean, showCard: boolean, ttl: number, xApiVersion: string, options?: { preserveFormat? : boolean, cardTypes? : string, pageHeader? : string, submitButtonText? : string, language? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, cartTableBorderColor? : string, cartTableAlternateRowColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a url to the card processing UI.
   *
   * The card processing UI allows your customers to enter their card data and
   * process upstream with the payment gateway without your app touching it.
   * Build out the request meant for the upstream url and then use the following
   * placeholders to have the endpoint populate them with card data: ${total},
   * ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
   * ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE. The customer is redirected
   * back to your app (callback url) via POST with the parameter eVsessionId. You
   * can then use /cardvault/process/sessions/ to determine the adjudication. The
   * session information is available for 72 hours. If the customer choses to
   * save their card, it will be available through the sessions endpoint. If the
   * customer chooses to cancel or if the form timeouts, evException will have a
   * value within the POST callback. For cancels, evException's value will be
   * 'cancel'. For timeouts, the evException's value will be 'timeout'. There are
   * multiple ways to integrate the card process form. You can use it within a
   * popup, redirect or simple iframe.
   *
   * @param {object} body Gateway and cart information.
   *
   * @param {object} body.gatewayRequest
   *
   * @param {string} body.gatewayRequest.url URL to use on the payment gateway
   * request.
   *
   * @param {string} body.gatewayRequest.httpMethod HTTP method to use on the
   * payment gateway request.
   *
   * @param {array} [body.gatewayRequest.headers] Headers to use on the payment
   * gateway request.
   *
   * @param {string} [body.gatewayRequest.body] Body to use on the payment
   * gateway request.
   *
   * @param {object} body.cart
   *
   * @param {string} body.cart.cultureCode ISO 639-1 (language) and ISO 3166-1
   * (country) code.
   *
   * @param {array} body.cart.cartItems List of cart items.
   *
   * @param {number} body.cart.total Total of the cart item amounts. The total is
   * validated against the
   * sum of the cart item amounts.
   *
   * @param {boolean} body.cart.gatewayIntegersOnly Some payment gateways only
   * accept integers. If true, it will multiply
   * the total by 100. For instance, 10.01 will be submitted to the gateway
   * as 1001.
   *
   * @param {string} callbackUrl URL the user is redirected to after storing the
   * card.
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCard Show or hide the card visual.
   *
   * @param {number} ttl Form session time to live in seconds. After it expires,
   * the form can no
   * longer be used.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {string} [options.cardTypes] Card types, comma delimited. Omit for
   * any card.
   * (amex, diners_club_carte_blanche, diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {string} [options.cartTableBorderColor] The hex color of the cart
   * table header and border.
   *
   * @param {string} [options.cartTableAlternateRowColor] The hex color of the
   * cart table's alternating rows.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCardProcessForm(body: models.CardProcessModel, callbackUrl: string, showTimer: boolean, showCard: boolean, ttl: number, xApiVersion: string, options?: { preserveFormat? : boolean, cardTypes? : string, pageHeader? : string, submitButtonText? : string, language? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, cartTableBorderColor? : string, cartTableAlternateRowColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCardProcessForm(body: models.CardProcessModel, callbackUrl: string, showTimer: boolean, showCard: boolean, ttl: number, xApiVersion: string, callback: ServiceCallback<any>): void;
  getCardProcessForm(body: models.CardProcessModel, callbackUrl: string, showTimer: boolean, showCard: boolean, ttl: number, xApiVersion: string, options: { preserveFormat? : boolean, cardTypes? : string, pageHeader? : string, submitButtonText? : string, language? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, cartTableBorderColor? : string, cartTableAlternateRowColor? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get card process session information.
   *
   * Obtain the results from the gateway and retrieve the card token if the
   * customer decided to save it.
   *
   * @param {uuid} id Session ID
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCardProcessSessionWithHttpOperationResponse(id: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get card process session information.
   *
   * Obtain the results from the gateway and retrieve the card token if the
   * customer decided to save it.
   *
   * @param {uuid} id Session ID
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCardProcessSession(id: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCardProcessSession(id: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getCardProcessSession(id: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a url to the card store UI.
   *
   * The card store form allows your app to store and later use customer card
   * data without touching it. After the cardTtl expires, the card is deleted. If
   * the user decides to save the card, the card is stored permanently. If you're
   * seeking to permanently store the card outside of a transaction (wallet
   * style), set walletSave to true. If you set walletSave to true, the
   * buttonText and cardTtl are overriden. If walletSave is true the CVV isn't
   * requested. If you intend to use the card in a transaction within 30 minutes,
   * set walletSave to false. On callback, your app will receive via POST the
   * card token within the parameter eVtoken. If the customer chooses to cancel
   * or if the form timeouts, the evException parameter will contain the reason.
   * For cancels, evException's value will be 'cancel'. For timeouts,
   * evException's value will be 'timeout'. If embedFormForControl is set to
   * true, pass 'submit' as a message over to the iframe to submit the form. On
   * response, the parent will receive an object that consists of the status, the
   * token, and CardModel object. There are multiple ways to integrate the card
   * store form. You can use it within a popup, redirect, simple iframe, or
   * iframe where the parent page has control to submit the form. You can find
   * example code for the advanced iframe integration on
   * [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCard Show or hide the card visual.
   *
   * @param {boolean} walletSave Make true to store the card in your app's
   * wallet. This overrides
   * the cardTtl and buttonText values. The CVV isn't requested if true.
   * If you intend to use the card in a transaction within 30 minutes,
   * set walletSave to false.
   *
   * @param {boolean} embedFormForControl If true, it removes its buttons and
   * any additional padding/spacing, and enables the windows interface for 2-way
   * comms.
   *
   * @param {number} ttl Form session time to live in seconds. After it expires,
   * the form can no
   * longer be used.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {number} [options.cardTtl] The card's time to live in seconds
   * (60-1800 secs).
   * Once expired the card is deleted from the vault. Use the
   * /cardvault/cards/ttl
   * endpoint to extend it. This field is required if walletSave is false.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {string} [options.cardTypes] Card types, comma delimited. Omit for
   * any card.
   * (amex, diners_club_carte_blanche, diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {string} [options.callbackUrl] URL the user is redirected to after
   * storing the card.
   *
   * @param {string} [options.parentUrl] The parent page URL. The store form uses
   * it when embedFormForControl
   * is true to communicate with the parent window.
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCardStoreFormWithHttpOperationResponse(showTimer: boolean, showCard: boolean, walletSave: boolean, embedFormForControl: boolean, ttl: number, xApiVersion: string, options?: { cardTtl? : number, preserveFormat? : boolean, cardTypes? : string, callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a url to the card store UI.
   *
   * The card store form allows your app to store and later use customer card
   * data without touching it. After the cardTtl expires, the card is deleted. If
   * the user decides to save the card, the card is stored permanently. If you're
   * seeking to permanently store the card outside of a transaction (wallet
   * style), set walletSave to true. If you set walletSave to true, the
   * buttonText and cardTtl are overriden. If walletSave is true the CVV isn't
   * requested. If you intend to use the card in a transaction within 30 minutes,
   * set walletSave to false. On callback, your app will receive via POST the
   * card token within the parameter eVtoken. If the customer chooses to cancel
   * or if the form timeouts, the evException parameter will contain the reason.
   * For cancels, evException's value will be 'cancel'. For timeouts,
   * evException's value will be 'timeout'. If embedFormForControl is set to
   * true, pass 'submit' as a message over to the iframe to submit the form. On
   * response, the parent will receive an object that consists of the status, the
   * token, and CardModel object. There are multiple ways to integrate the card
   * store form. You can use it within a popup, redirect, simple iframe, or
   * iframe where the parent page has control to submit the form. You can find
   * example code for the advanced iframe integration on
   * [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCard Show or hide the card visual.
   *
   * @param {boolean} walletSave Make true to store the card in your app's
   * wallet. This overrides
   * the cardTtl and buttonText values. The CVV isn't requested if true.
   * If you intend to use the card in a transaction within 30 minutes,
   * set walletSave to false.
   *
   * @param {boolean} embedFormForControl If true, it removes its buttons and
   * any additional padding/spacing, and enables the windows interface for 2-way
   * comms.
   *
   * @param {number} ttl Form session time to live in seconds. After it expires,
   * the form can no
   * longer be used.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {number} [options.cardTtl] The card's time to live in seconds
   * (60-1800 secs).
   * Once expired the card is deleted from the vault. Use the
   * /cardvault/cards/ttl
   * endpoint to extend it. This field is required if walletSave is false.
   *
   * @param {boolean} [options.preserveFormat] If true, a Luhn passable token is
   * returned consisting of the original first six and last four.
   *
   * @param {string} [options.cardTypes] Card types, comma delimited. Omit for
   * any card.
   * (amex, diners_club_carte_blanche, diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   *
   * @param {string} [options.callbackUrl] URL the user is redirected to after
   * storing the card.
   *
   * @param {string} [options.parentUrl] The parent page URL. The store form uses
   * it when embedFormForControl
   * is true to communicate with the parent window.
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCardStoreForm(showTimer: boolean, showCard: boolean, walletSave: boolean, embedFormForControl: boolean, ttl: number, xApiVersion: string, options?: { cardTtl? : number, preserveFormat? : boolean, cardTypes? : string, callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCardStoreForm(showTimer: boolean, showCard: boolean, walletSave: boolean, embedFormForControl: boolean, ttl: number, xApiVersion: string, callback: ServiceCallback<any>): void;
  getCardStoreForm(showTimer: boolean, showCard: boolean, walletSave: boolean, embedFormForControl: boolean, ttl: number, xApiVersion: string, options: { cardTtl? : number, preserveFormat? : boolean, cardTypes? : string, callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a url to the CVV store UI.
   *
   * The CVV store form allows your app to temporarily store the CVV until
   * authorization. The CVV ttl is set to the card's ttl. If the card has a ttl
   * of -1, the CVV ttl will be set to 1800 seconds. If autoSave is true, the
   * callback will not trigger so the client app will need to verify the cvv ttl
   * for its existence. There are multiple ways to integrate the cvv form. You
   * can use it within a popup, redirect, simple iframe, (previous 3 can use
   * autosave) or iframe where the parent page has control to submit the form.
   * You can find example code for the advanced iframe integration on
   * [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
   *
   * @param {string} cardToken Card token.
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCancelButton Show or hide the cancel button.
   *
   * @param {boolean} autoSave If true, the buttons and header are removed, and
   * cvv will be autosaved after user entry.
   * The callback will not trigger so the client app will need to verify the cvv
   * ttl for its existence.
   *
   * @param {boolean} embedFormForControl If true, it removes its buttons and
   * any additional padding/spacing, and enables the windows interface for 2-way
   * comms.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {string} [options.callbackUrl] URL the user is redirected to after
   * storing the card.
   *
   * @param {string} [options.parentUrl] The parent page URL. The store form uses
   * it when embedFormForControl
   * is true to communicate with the parent window.
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCvvStoreFormWithHttpOperationResponse(cardToken: string, showTimer: boolean, showCancelButton: boolean, autoSave: boolean, embedFormForControl: boolean, xApiVersion: string, options?: { callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a url to the CVV store UI.
   *
   * The CVV store form allows your app to temporarily store the CVV until
   * authorization. The CVV ttl is set to the card's ttl. If the card has a ttl
   * of -1, the CVV ttl will be set to 1800 seconds. If autoSave is true, the
   * callback will not trigger so the client app will need to verify the cvv ttl
   * for its existence. There are multiple ways to integrate the cvv form. You
   * can use it within a popup, redirect, simple iframe, (previous 3 can use
   * autosave) or iframe where the parent page has control to submit the form.
   * You can find example code for the advanced iframe integration on
   * [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
   *
   * @param {string} cardToken Card token.
   *
   * @param {boolean} showTimer Show or hide the timer.
   *
   * @param {boolean} showCancelButton Show or hide the cancel button.
   *
   * @param {boolean} autoSave If true, the buttons and header are removed, and
   * cvv will be autosaved after user entry.
   * The callback will not trigger so the client app will need to verify the cvv
   * ttl for its existence.
   *
   * @param {boolean} embedFormForControl If true, it removes its buttons and
   * any additional padding/spacing, and enables the windows interface for 2-way
   * comms.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {string} [options.callbackUrl] URL the user is redirected to after
   * storing the card.
   *
   * @param {string} [options.parentUrl] The parent page URL. The store form uses
   * it when embedFormForControl
   * is true to communicate with the parent window.
   *
   * @param {string} [options.pageHeader] Configurable page header.
   *
   * @param {string} [options.language] The language to use on the form.
   * Currently en (English), es (Spanish),
   * fr (French), and zh-Hans (Chinese simplified) are available.
   *
   * @param {string} [options.submitButtonText] Text of the submit button.
   *
   * @param {string} [options.submitButtonColor] The hex color of the submit
   * button.
   *
   * @param {string} [options.cancelButtonColor] The hex color of the cancel
   * button.
   *
   * @param {string} [options.pageColor] The hex color of the page background.
   *
   * @param {string} [options.submitButtonTextColor] The hex color of the submit
   * button text.
   *
   * @param {string} [options.cancelButtonTextColor] The hex color of the cancel
   * button text.
   *
   * @param {string} [options.pageTextColor] The hex color of the page text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCvvStoreForm(cardToken: string, showTimer: boolean, showCancelButton: boolean, autoSave: boolean, embedFormForControl: boolean, xApiVersion: string, options?: { callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCvvStoreForm(cardToken: string, showTimer: boolean, showCancelButton: boolean, autoSave: boolean, embedFormForControl: boolean, xApiVersion: string, callback: ServiceCallback<any>): void;
  getCvvStoreForm(cardToken: string, showTimer: boolean, showCancelButton: boolean, autoSave: boolean, embedFormForControl: boolean, xApiVersion: string, options: { callbackUrl? : string, parentUrl? : string, pageHeader? : string, language? : string, submitButtonText? : string, submitButtonColor? : string, cancelButtonColor? : string, pageColor? : string, submitButtonTextColor? : string, cancelButtonTextColor? : string, pageTextColor? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a listing of all supported cultures and currencies.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {string} [options.cultureCode] ISO 639-1 (language) and ISO 3166-1
   * (country) code.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getCulturesWithHttpOperationResponse(xApiVersion: string, options?: { cultureCode? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a listing of all supported cultures and currencies.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {string} [options.cultureCode] ISO 639-1 (language) and ISO 3166-1
   * (country) code.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getCultures(xApiVersion: string, options?: { cultureCode? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getCultures(xApiVersion: string, callback: ServiceCallback<any>): void;
  getCultures(xApiVersion: string, options: { cultureCode? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Store a secret.
   *
   * Supports up to 5,000 plaintext objects per request. Plaintext strings must
   * be less than 1000 characters in length. The customIdentifier attribute ties
   * your unencrypted data to the tokens. The customIdentifier is not stored
   * within the vault.
   *
   * @param {array} body Your secrets to vault.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  storeDataSecretsWithHttpOperationResponse(body: models.PlaintextCustomerIdentifierModel[], xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Store a secret.
   *
   * Supports up to 5,000 plaintext objects per request. Plaintext strings must
   * be less than 1000 characters in length. The customIdentifier attribute ties
   * your unencrypted data to the tokens. The customIdentifier is not stored
   * within the vault.
   *
   * @param {array} body Your secrets to vault.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  storeDataSecrets(body: models.PlaintextCustomerIdentifierModel[], xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  storeDataSecrets(body: models.PlaintextCustomerIdentifierModel[], xApiVersion: string, callback: ServiceCallback<any>): void;
  storeDataSecrets(body: models.PlaintextCustomerIdentifierModel[], xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a secret by token.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain the token's secret. To generate one, use the
   * datavault/secrets/ephemeralKey endpoint.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] One time use expiring key.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getDataSecretWithHttpOperationResponse(token: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a secret by token.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain the token's secret. To generate one, use the
   * datavault/secrets/ephemeralKey endpoint.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] One time use expiring key.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getDataSecret(token: string, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getDataSecret(token: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getDataSecret(token: string, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Delete a secret.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  deleteDataSecretWithHttpOperationResponse(token: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Delete a secret.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  deleteDataSecret(token: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  deleteDataSecret(token: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  deleteDataSecret(token: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Search by plaintext.
   *
   * Exact matches will only be returned and is case sensitive.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.body] Text to search within the vault. Exact
   * matches will only be returned and is case sensitive.
   *
   * @param {string} options.body.plaintext Secret text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  searchDataSecretsWithHttpOperationResponse(xApiVersion: string, options?: { body? : models.PlaintextModel, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Search by plaintext.
   *
   * Exact matches will only be returned and is case sensitive.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.body] Text to search within the vault. Exact
   * matches will only be returned and is case sensitive.
   *
   * @param {string} options.body.plaintext Secret text.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  searchDataSecrets(xApiVersion: string, options?: { body? : models.PlaintextModel, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  searchDataSecrets(xApiVersion: string, callback: ServiceCallback<any>): void;
  searchDataSecrets(xApiVersion: string, options: { body? : models.PlaintextModel, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get an ephemeral key for a specific token and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain the token's secret. The destinationClientId is a valid
   * Enigma Vault clientId of the destination app. The time to live (ttl) is in
   * seconds.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {number} ttl Time to live in seconds, max of 300.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getDataEphemeralKeyWithHttpOperationResponse(token: string, destinationClientId: string, ttl: number, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get an ephemeral key for a specific token and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain the token's secret. The destinationClientId is a valid
   * Enigma Vault clientId of the destination app. The time to live (ttl) is in
   * seconds.
   *
   * @param {string} token Reference to the vaulted secret.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {number} ttl Time to live in seconds, max of 300.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getDataEphemeralKey(token: string, destinationClientId: string, ttl: number, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getDataEphemeralKey(token: string, destinationClientId: string, ttl: number, xApiVersion: string, callback: ServiceCallback<any>): void;
  getDataEphemeralKey(token: string, destinationClientId: string, ttl: number, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a url to upload a file.
   *
   * The url is used to upload (PUT) a file into the vault. The url has an
   * exipration of five minutes. The file size cannot exceed 5 gigabytes. A
   * websocket url is provided so that the status of the file can be tracked in
   * realtime.
   *
   * @param {string} contentType The MIME type associated with the file.
   *
   * @param {string} fileExtension The file extension without the leading .
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getUploadUrlWithHttpOperationResponse(contentType: string, fileExtension: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a url to upload a file.
   *
   * The url is used to upload (PUT) a file into the vault. The url has an
   * exipration of five minutes. The file size cannot exceed 5 gigabytes. A
   * websocket url is provided so that the status of the file can be tracked in
   * realtime.
   *
   * @param {string} contentType The MIME type associated with the file.
   *
   * @param {string} fileExtension The file extension without the leading .
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getUploadUrl(contentType: string, fileExtension: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getUploadUrl(contentType: string, fileExtension: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getUploadUrl(contentType: string, fileExtension: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get the status of a file.
   *
   * This endpoint has been deprecated because the file status is now provided
   * through a websocket API.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getFileStatusWithHttpOperationResponse(fileName: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get the status of a file.
   *
   * This endpoint has been deprecated because the file status is now provided
   * through a websocket API.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getFileStatus(fileName: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getFileStatus(fileName: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  getFileStatus(fileName: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get a url to decrypt and download the file.
   *
   * The url is used to download the file out of the vault. The url has an
   * exipration of five minutes. When aSync is set to true for large files, a
   * websocket API url is returned so that the file status can be monitored in
   * real time. When the file is finished decrypting, the download url is
   * provided through the websocket connection.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {boolean} aSync Set to true to decrypt large files; you'll use the
   * websocket API for notifications.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] One time use expiring key.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getDownloadUrlWithHttpOperationResponse(fileName: string, aSync: boolean, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get a url to decrypt and download the file.
   *
   * The url is used to download the file out of the vault. The url has an
   * exipration of five minutes. When aSync is set to true for large files, a
   * websocket API url is returned so that the file status can be monitored in
   * real time. When the file is finished decrypting, the download url is
   * provided through the websocket connection.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {boolean} aSync Set to true to decrypt large files; you'll use the
   * websocket API for notifications.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {uuid} [options.ephemeralKey] One time use expiring key.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getDownloadUrl(fileName: string, aSync: boolean, xApiVersion: string, options?: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getDownloadUrl(fileName: string, aSync: boolean, xApiVersion: string, callback: ServiceCallback<any>): void;
  getDownloadUrl(fileName: string, aSync: boolean, xApiVersion: string, options: { ephemeralKey? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Delete a file.
   *
   * On successful deletion, a 204 response is returned.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  deleteFileWithHttpOperationResponse(fileName: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Delete a file.
   *
   * On successful deletion, a 204 response is returned.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  deleteFile(fileName: string, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  deleteFile(fileName: string, xApiVersion: string, callback: ServiceCallback<any>): void;
  deleteFile(fileName: string, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;


  /**
   * @summary Get an ephemeral key for a specific fileName and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain a download url. The destinationClientId is a valid Enigma
   * Vault clientId of the destination app. The time to live (ttl) is in seconds.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {number} ttl Time to live in seconds, max of 300.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @returns {Promise} A promise is returned
   *
   * @resolve {HttpOperationResponse<Object>} - The deserialized result object.
   *
   * @reject {Error|ServiceError} - The error object.
   */
  getFileEphemeralKeyWithHttpOperationResponse(fileName: string, destinationClientId: string, ttl: number, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<any>>;

  /**
   * @summary Get an ephemeral key for a specific fileName and client.
   *
   * The ephemeralKey is a one time use expiring key that allows an external
   * client to obtain a download url. The destinationClientId is a valid Enigma
   * Vault clientId of the destination app. The time to live (ttl) is in seconds.
   *
   * @param {string} fileName Tokenized file name.
   *
   * @param {string} destinationClientId Enigma Vault client granted use of the
   * ephemeralKey.
   *
   * @param {number} ttl Time to live in seconds, max of 300.
   *
   * @param {string} xApiVersion The requested API version
   *
   * @param {object} [options] Optional Parameters.
   *
   * @param {object} [options.customHeaders] Headers that will be added to the
   * request
   *
   * @param {ServiceCallback} [optionalCallback] - The optional callback.
   *
   * @returns {ServiceCallback|Promise} If a callback was passed as the last
   * parameter then it returns the callback else returns a Promise.
   *
   * {Promise} A promise is returned.
   *
   *                      @resolve {Object} - The deserialized result object.
   *
   *                      @reject {Error|ServiceError} - The error object.
   *
   * {ServiceCallback} optionalCallback(err, result, request, response)
   *
   *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
   *
   *                      {Object} [result]   - The deserialized result object if an error did not occur.
   *
   *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
   *
   *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
   */
  getFileEphemeralKey(fileName: string, destinationClientId: string, ttl: number, xApiVersion: string, options?: { customHeaders? : { [headerName: string]: string; } }): Promise<any>;
  getFileEphemeralKey(fileName: string, destinationClientId: string, ttl: number, xApiVersion: string, callback: ServiceCallback<any>): void;
  getFileEphemeralKey(fileName: string, destinationClientId: string, ttl: number, xApiVersion: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;
}

export { EnigmaVaultAPI, models as EnigmaVaultAPIModels };
