/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CardModel.
 */
class CardModel {
  /**
   * Create a CardModel.
   * @property {string} ccn Card number.
   * @property {string} fullName Full name located on the card.
   * @property {number} expMonth Expiration month.
   * @property {number} expYear Expiration year.
   * @property {string} [cvv] Card verification value (security code). This
   * value is not stored permanently.
   * @property {string} cardType Type of card (amex, diners_club_carte_blanche,
   * diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   * @property {number} cvvTtl Remaining ttl before the CVV gets deleted.
   * @property {number} [ttl] The card's time to live in seconds. Once expired
   * the
   * card is deleted from the vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CardModel
   *
   * @returns {object} metadata of CardModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CardModel',
      type: {
        name: 'Composite',
        className: 'CardModel',
        modelProperties: {
          ccn: {
            required: true,
            serializedName: 'ccn',
            type: {
              name: 'String'
            }
          },
          fullName: {
            required: true,
            serializedName: 'fullName',
            type: {
              name: 'String'
            }
          },
          expMonth: {
            required: true,
            serializedName: 'expMonth',
            constraints: {
              InclusiveMaximum: 12,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          expYear: {
            required: true,
            serializedName: 'expYear',
            type: {
              name: 'Number'
            }
          },
          cvv: {
            required: false,
            serializedName: 'cvv',
            type: {
              name: 'String'
            }
          },
          cardType: {
            required: true,
            serializedName: 'cardType',
            type: {
              name: 'String'
            }
          },
          cvvTtl: {
            required: true,
            serializedName: 'cvvTtl',
            constraints: {
              InclusiveMaximum: 1800,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          ttl: {
            required: false,
            nullable: true,
            serializedName: 'ttl',
            constraints: {
              InclusiveMaximum: 1800,
              InclusiveMinimum: 60
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CardModel;
