/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CardReadModel.
 */
class CardReadModel {
  /**
   * Create a CardReadModel.
   * @property {string} firstSix First six digits of the card number.
   * @property {string} lastFour Last four digits of the card number.
   * @property {string} [ccn] Card number.
   * @property {number} expMonth Expiration month.
   * @property {number} expYear Expiration year.
   * @property {string} fullName Full name located on the card.
   * @property {string} cardType Type of card (amex, diners_club_carte_blanche,
   * diners_club_international,
   * jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
   * uatp, mir).
   * @property {number} cvvTtl Remaining ttl before the CVV gets deleted.
   * @property {number} ttl Remaining ttl before the card gets deleted. If -1,
   * card lives forever until manually deleted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CardReadModel
   *
   * @returns {object} metadata of CardReadModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CardReadModel',
      type: {
        name: 'Composite',
        className: 'CardReadModel',
        modelProperties: {
          firstSix: {
            required: true,
            serializedName: 'firstSix',
            type: {
              name: 'String'
            }
          },
          lastFour: {
            required: true,
            serializedName: 'lastFour',
            type: {
              name: 'String'
            }
          },
          ccn: {
            required: false,
            serializedName: 'ccn',
            type: {
              name: 'String'
            }
          },
          expMonth: {
            required: true,
            serializedName: 'expMonth',
            constraints: {
              InclusiveMaximum: 12,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          expYear: {
            required: true,
            serializedName: 'expYear',
            type: {
              name: 'Number'
            }
          },
          fullName: {
            required: true,
            serializedName: 'fullName',
            type: {
              name: 'String'
            }
          },
          cardType: {
            required: true,
            serializedName: 'cardType',
            type: {
              name: 'String'
            }
          },
          cvvTtl: {
            required: true,
            serializedName: 'cvvTtl',
            constraints: {
              InclusiveMaximum: 1800,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          ttl: {
            required: true,
            serializedName: 'ttl',
            constraints: {
              InclusiveMaximum: 1800,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CardReadModel;
